# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class Member(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, id: int=None, name: str=None, birth_year: int=None, gender: str=None, plan: str=None):  # noqa: E501
        """Member - a model defined in Swagger

        :param id: The id of this Member.  # noqa: E501
        :type id: int
        :param name: The name of this Member.  # noqa: E501
        :type name: str
        :param birth_year: The birth_year of this Member.  # noqa: E501
        :type birth_year: int
        :param gender: The gender of this Member.  # noqa: E501
        :type gender: str
        :param plan: The plan of this Member.  # noqa: E501
        :type plan: str
        """
        self.swagger_types = {
            'id': int,
            'name': str,
            'birth_year': int,
            'gender': str,
            'plan': str
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'birth_year': 'birthYear',
            'gender': 'gender',
            'plan': 'plan'
        }
        self._id = id
        self._name = name
        self._birth_year = birth_year
        self._gender = gender
        self._plan = plan

    @classmethod
    def from_dict(cls, dikt) -> 'Member':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The member of this Member.  # noqa: E501
        :rtype: Member
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this Member.

        Unique identifier for the member  # noqa: E501

        :return: The id of this Member.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this Member.

        Unique identifier for the member  # noqa: E501

        :param id: The id of this Member.
        :type id: int
        """

        self._id = id

    @property
    def name(self) -> str:
        """Gets the name of this Member.

        First name  # noqa: E501

        :return: The name of this Member.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this Member.

        First name  # noqa: E501

        :param name: The name of this Member.
        :type name: str
        """

        self._name = name

    @property
    def birth_year(self) -> int:
        """Gets the birth_year of this Member.

        Year of birth (4-digit format YYYY)  # noqa: E501

        :return: The birth_year of this Member.
        :rtype: int
        """
        return self._birth_year

    @birth_year.setter
    def birth_year(self, birth_year: int):
        """Sets the birth_year of this Member.

        Year of birth (4-digit format YYYY)  # noqa: E501

        :param birth_year: The birth_year of this Member.
        :type birth_year: int
        """

        self._birth_year = birth_year

    @property
    def gender(self) -> str:
        """Gets the gender of this Member.

        Gender (M for Male, F for Female)  # noqa: E501

        :return: The gender of this Member.
        :rtype: str
        """
        return self._gender

    @gender.setter
    def gender(self, gender: str):
        """Sets the gender of this Member.

        Gender (M for Male, F for Female)  # noqa: E501

        :param gender: The gender of this Member.
        :type gender: str
        """
        allowed_values = ["M", "F"]  # noqa: E501
        if gender not in allowed_values:
            raise ValueError(
                "Invalid value for `gender` ({0}), must be one of {1}"
                .format(gender, allowed_values)
            )

        self._gender = gender

    @property
    def plan(self) -> str:
        """Gets the plan of this Member.

        Subscription plan  # noqa: E501

        :return: The plan of this Member.
        :rtype: str
        """
        return self._plan

    @plan.setter
    def plan(self, plan: str):
        """Sets the plan of this Member.

        Subscription plan  # noqa: E501

        :param plan: The plan of this Member.
        :type plan: str
        """
        allowed_values = ["free", "regular", "premium"]  # noqa: E501
        if plan not in allowed_values:
            raise ValueError(
                "Invalid value for `plan` ({0}), must be one of {1}"
                .format(plan, allowed_values)
            )

        self._plan = plan
