# coding: utf-8

from __future__ import absolute_import

from flask import json
from six import BytesIO

from swagger_server.models.member import Member  # noqa: E501
from swagger_server.test import BaseTestCase


class TestAssociationController(BaseTestCase):
    """AssociationController integration test stubs"""

    def test_add_member(self):
        """Test case for add_member

        Add a new member
        """
        body = Member()
        data = dict(id=56,
                    name='name_example',
                    birth_year=2023,
                    gender='gender_example',
                    plan='plan_example')
        response = self.client.open(
            '/assocation/member',
            method='POST',
            data=json.dumps(body),
            data=data,
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_delete_member(self):
        """Test case for delete_member

        Delete a member
        """
        response = self.client.open(
            '/assocation/member/{member_id}''.format(member_id=789),
            method='DELETE')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_all_members(self):
        """Test case for get_all_members

        List all members
        """
        response = self.client.open(
            '/assocation/members',
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_member_by_id(self):
        """Test case for get_member_by_id

        Find member by ID
        """
        response = self.client.open(
            '/assocation/member/{member_id}''.format(member_id=789),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_reset(self):
        """Test case for reset

        Restart a fresh empty list of members
        """
        response = self.client.open(
            '/assocation/reset',
            method='DELETE')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_update_member(self):
        """Test case for update_member

        Update an existing member
        """
        body = Member()
        data = dict(id=56,
                    name='name_example',
                    birth_year=2023,
                    gender='gender_example',
                    plan='plan_example')
        response = self.client.open(
            '/assocation/member',
            method='PUT',
            data=json.dumps(body),
            data=data,
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    import unittest
    unittest.main()
